<?php
namespace Guestbook\CaGuestbook\Domain\Model;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2015
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Entries
 */
class Entries extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity {


    /**
     * CAPTCHA
     *
     * @var string
     * @validate \Guestbook\CaGuestbook\Domain\Validator\CaptchaValidator;
     */
    protected $captcha;

	/**
	 * name
	 *
	 * @var string
     * @validate NotEmpty
	 */
	protected $name = '';

	/**
	 * email
	 *
	 * @var string
     * @validate EmailAddress
	 */
	protected $email = '';
    
    
	/**
	 * url
	 *
	 * @var string
	 */
	protected $url = '';    


	/**
	 * text
	 *
	 * @var string
     * @validate NotEmpty
	 */
	protected $text = '';

	/**
	 * subject
	 *
	 * @var string
	 */
	protected $subject = '';

	/**
	 * date
	 *
    * @var integer
    */
    protected $date;



    public function __construct(){
        $this->date = time();
    }


	/**
	 * Returns the name
	 *
	 * @return string $name
	 */
	public function getName() {
		return $this->name;
	}

	/**
	 * Sets the name
	 *
	 * @param string $name
	 * @return void
	 */
	public function setName($name) {
		$this->name = $name;
	}

	/**
	 * Returns the captcha
	 *
	 * @return string $captcha
	 */
	public function getCaptcha() {
		return $_REQUEST["g-recaptcha-response"];
	}


	/**
	 * Returns the text
	 *
	 * @return string $text
	 */
	public function getText() {
		return $this->text;
	}

	/**
	 * Sets the text
	 *
	 * @param string $text
	 * @return void
	 */
	public function setText($text) {
		$this->text = $text;
	}


	/**
	 * Returns the subject
	 *
	 * @return string $subject
	 */
	public function getSubject() {
		return $this->subject;
	}

	/**
	 * Sets the subject
	 *
	 * @param string $subject
	 * @return void
	 */
	public function setSubject($subject) {
		$this->subject = $subject;
	}


	/**
	 * Sets the date
	 *
	 * @param integer $date
	 * @return void
	 */
	public function setDate($date) {
		$this->date = $date;
	}


    /**
    * @return integer $date
    */
    public function getDate() {
        return $this->date;
    }
    
    /**
	 * Returns the url
	 *
	 * @return string $url
	 */
	public function getUrl() {
		return $this->url;
	}

	/**
	 * Sets the url
	 *
	 * @param string $url
	 * @return void
	 */
	public function setUrl($url) {
		$this->url = $url;
	}
    
    /**
	 * Returns the email
	 *
	 * @return string $email
	 */
	public function getEmail() {
		return $this->email;
	}

	/**
	 * Sets the email
	 *
	 * @param string $email
	 * @return void
	 */
	public function setEmail($email) {
		$this->email = $email;
	}

}