<?PHP
namespace Guestbook\CaGuestbook\Domain\Validator;

use TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface;

/**
 * Validator for captcha values.
 *
 * @api
 */
class CaptchaValidator extends \TYPO3\CMS\Extbase\Validation\Validator\AbstractValidator {

        /**
         * This validator always needs to be executed even if the given value is empty.
         * See AbstractValidator::validate()
         *
         * @var boolean
         */
        protected $acceptsEmptyValues = FALSE;


    	/**
    	 * @var \TYPO3\CMS\Extbase\Object\ObjectManagerInterface
    	 *
    	 * @inject
    	 */
    	protected $objectManager;

		/**
        * @var \TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface
        * @inject
        */
        protected $configurationManager;

		/**
		 * Settings
		 *
		 * @var array
		 */
		protected $settings = array();	
	
	
        /**
        * Injects the configuration manager, retrieves the plugin settings from it
        *
        * @param \TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface $configurationManager
        * @return void
        * @override \TYPO3\CMS\Extbase\Mvc\Controller\AbstractController
        **/
        public function injectConfigurationManager(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface $configurationManager) {
            /*$this->configurationManager = $configurationManager;
            $settings = $this->configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_SETTINGS);
            $this->settings = $settings;
            var_dump($this->settings);*/
        }
       
        	
	
        /**
         * Checks if the given property ($propertyValue) is not empty (NULL, empty string, empty array or empty object).
         *
         * @param mixed $value The value that should be validated
         * @return void
         */
        public function isValid($value) {
            $objectManager =  \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Object\\ObjectManager');
            $configurationManager =  $objectManager->get('TYPO3\\CMS\\Extbase\\Configuration\\ConfigurationManagerInterface'); 
            $settings = $configurationManager->getConfiguration(\TYPO3\CMS\Extbase\Configuration\ConfigurationManagerInterface::CONFIGURATION_TYPE_SETTINGS);
            
            if ($value === NULL || $value === '') {
                $this->addError("Captcha empty", time());
            }
            
            if($settings === NULL) {
                $this->addError("Settings Error", time());
            }
            //print_r($settings);
            $secretKey = $settings["reCaptcha"]["secretkey"];
            //echo "https://www.google.com/recaptcha/api/siteverify?secret=".$secretKey."&response=".$value."&remoteip=".$_SERVER['REMOTE_ADDR'];
           $response=file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=".$secretKey."&response=".$value."&remoteip=".$_SERVER['REMOTE_ADDR']);
            $response = json_decode($response);
			if(!$response->success)
            {
                $this->addError('Captcha wrong', time());
            }
        }
}


?>