<?php
namespace Guestbook\CaGuestbook\Tests\Unit\Controller;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2015 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class Guestbook\CaGuestbook\Controller\EntriesController.
 *
 */
class EntriesControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {

	/**
	 * @var \Guestbook\CaGuestbook\Controller\EntriesController
	 */
	protected $subject = NULL;

	protected function setUp() {
		$this->subject = $this->getMock('Guestbook\\CaGuestbook\\Controller\\EntriesController', array('redirect', 'forward', 'addFlashMessage'), array(), '', FALSE);
	}

	protected function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function listActionFetchesAllEntriessFromRepositoryAndAssignsThemToView() {

		$allEntriess = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array(), array(), '', FALSE);

		$entriesRepository = $this->getMock('Guestbook\\CaGuestbook\\Domain\\Repository\\EntriesRepository', array('findAll'), array(), '', FALSE);
		$entriesRepository->expects($this->once())->method('findAll')->will($this->returnValue($allEntriess));
		$this->inject($this->subject, 'entriesRepository', $entriesRepository);

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('entriess', $allEntriess);
		$this->inject($this->subject, 'view', $view);

		$this->subject->listAction();
	}

	/**
	 * @test
	 */
	public function newActionAssignsTheGivenEntriesToView() {
		$entries = new \Guestbook\CaGuestbook\Domain\Model\Entries();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('newEntries', $entries);
		$this->inject($this->subject, 'view', $view);

		$this->subject->newAction($entries);
	}

	/**
	 * @test
	 */
	public function createActionAddsTheGivenEntriesToEntriesRepository() {
		$entries = new \Guestbook\CaGuestbook\Domain\Model\Entries();

		$entriesRepository = $this->getMock('Guestbook\\CaGuestbook\\Domain\\Repository\\EntriesRepository', array('add'), array(), '', FALSE);
		$entriesRepository->expects($this->once())->method('add')->with($entries);
		$this->inject($this->subject, 'entriesRepository', $entriesRepository);

		$this->subject->createAction($entries);
	}
}
